<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>DataValidationEvaluator (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="DataValidationEvaluator (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":9,"i5":10,"i6":9,"i7":10};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/DataValidationEvaluator.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html"
               title="class in org.apache.poi.ss.formula"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.DataValidationContext.html"
               title="class in org.apache.poi.ss.formula"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/ss/formula/DataValidationEvaluator.html" target="_top">Frames</a>
        </li>
        <li><a href="DataValidationEvaluator.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.ss.formula</div>
    <h2 title="Class DataValidationEvaluator" class="title">Class DataValidationEvaluator</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.ss.formula.DataValidationEvaluator</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <hr>
                <br>
                <pre>public class <span class="typeNameLabel">DataValidationEvaluator</span>
extends java.lang.Object</pre>
                <div class="block">Evaluates Data Validation constraints.<p>

                    For performance reasons, this class keeps a cache of all previously retrieved <a
                        href="../../../../../org/apache/poi/ss/usermodel/DataValidation.html"
                        title="interface in org.apache.poi.ss.usermodel"><code>DataValidation</code></a> instances.
                    Be sure to call <a
                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.html#clearAllCachedValues--"><code>clearAllCachedValues()</code></a>
                    if any workbook validation definitions are
                    added, modified, or deleted.
                    <p>
                        Changing cell values should be fine, as long as the corresponding <a
                            href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#clearAllCachedResultValues--"><code>WorkbookEvaluator.clearAllCachedResultValues()</code></a>
                        is called as well.</div>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ======== NESTED CLASS SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="nested.class.summary">
                        <!--   -->
                    </a>
                        <h3>Nested Class Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Nested Class Summary table, listing nested classes, and an explanation">
                            <caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Class and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>static class&nbsp;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.DataValidationContext.html"
                                        title="class in org.apache.poi.ss.formula">DataValidationEvaluator.DataValidationContext</a></span></code>
                                    <div class="block">This class organizes and encapsulates all the pieces of
                                        information related to a single
                                        data validation configuration for a single cell.
                                    </div>
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colFirst"><code>static class&nbsp;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.OperatorEnum.html"
                                        title="enum in org.apache.poi.ss.formula">DataValidationEvaluator.OperatorEnum</a></span></code>
                                    <div class="block">Not calling it OperatorType to avoid confusion for now with
                                        DataValidationConstraint.OperatorType.
                                    </div>
                                </td>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>static class&nbsp;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.ValidationEnum.html"
                                        title="enum in org.apache.poi.ss.formula">DataValidationEvaluator.ValidationEnum</a></span></code>
                                    <div class="block">Not calling it ValidationType to avoid confusion for now with
                                        DataValidationConstraint.ValidationType.
                                    </div>
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colOne" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.html#DataValidationEvaluator-org.apache.poi.ss.usermodel.Workbook-org.apache.poi.ss.formula.WorkbookEvaluatorProvider-">DataValidationEvaluator</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Workbook.html"
                                        title="interface in org.apache.poi.ss.usermodel">Workbook</a>&nbsp;wb,
                                    <a href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluatorProvider.html"
                                       title="interface in org.apache.poi.ss.formula">WorkbookEvaluatorProvider</a>&nbsp;provider)</code>
                                    <div class="block">Use the same formula evaluation context used for other
                                        operations, so cell value
                                        changes are automatically noticed
                                    </div>
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t1" class="tableTab"><span><a
                                    href="javascript:show(1);">Static Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.html#clearAllCachedValues--">clearAllCachedValues</a></span>()</code>
                                    <div class="block">Call this whenever validation structures change,
                                        so future results stay in sync with the Workbook state.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.DataValidationContext.html"
                                        title="class in org.apache.poi.ss.formula">DataValidationEvaluator.DataValidationContext</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.html#getValidationContextForCell-org.apache.poi.ss.util.CellReference-">getValidationContextForCell</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                        title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;cell)</code>
                                    <div class="block">Finds and returns the <a
                                            href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.DataValidationContext.html"
                                            title="class in org.apache.poi.ss.formula"><code>DataValidationEvaluator.DataValidationContext</code></a>
                                        for the cell, if there is
                                        one.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataValidation.html"
                                        title="interface in org.apache.poi.ss.usermodel">DataValidation</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.html#getValidationForCell-org.apache.poi.ss.util.CellReference-">getValidationForCell</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                        title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;cell)</code>
                                    <div class="block">Finds and returns the <a
                                            href="../../../../../org/apache/poi/ss/usermodel/DataValidation.html"
                                            title="interface in org.apache.poi.ss.usermodel"><code>DataValidation</code></a>
                                        for the cell, if there is
                                        one.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code>java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&gt;</code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.html#getValidationValuesForCell-org.apache.poi.ss.util.CellReference-">getValidationValuesForCell</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                        title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;cell)</code>
                                    <div class="block">If <a
                                            href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.html#getValidationForCell-org.apache.poi.ss.util.CellReference-"><code>getValidationForCell(CellReference)</code></a>
                                        returns an instance, and the
                                        <a href="../../../../../org/apache/poi/ss/usermodel/DataValidationConstraint.ValidationType.html"
                                           title="class in org.apache.poi.ss.usermodel"><code>DataValidationConstraint.ValidationType</code></a>
                                        is
                                        <a href="../../../../../org/apache/poi/ss/usermodel/DataValidationConstraint.ValidationType.html#LIST"><code>DataValidationConstraint.ValidationType.LIST</code></a>,
                                        return the valid
                                        values, whether they are from a static list or cell range.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code>protected static java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&gt;</code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.html#getValidationValuesForConstraint-org.apache.poi.ss.formula.DataValidationEvaluator.DataValidationContext-">getValidationValuesForConstraint</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.DataValidationContext.html"
                                        title="class in org.apache.poi.ss.formula">DataValidationEvaluator.DataValidationContext</a>&nbsp;context)</code>
                                    <div class="block">static so enums can reference it without creating a whole
                                        instance
                                    </div>
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code>protected <a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html"
                                        title="class in org.apache.poi.ss.formula">WorkbookEvaluator</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.html#getWorkbookEvaluator--">getWorkbookEvaluator</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code>static boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.html#isType-org.apache.poi.ss.usermodel.Cell-org.apache.poi.ss.usermodel.CellType-">isType</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&nbsp;cell,
                                    <a href="../../../../../org/apache/poi/ss/usermodel/CellType.html"
                                       title="enum in org.apache.poi.ss.usermodel">CellType</a>&nbsp;type)</code>
                                    <div class="block">Note that this assumes the cell cached value is up to date and in
                                        sync with data edits
                                    </div>
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code>boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.html#isValidCell-org.apache.poi.ss.util.CellReference-">isValidCell</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                        title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;cellRef)</code>
                                    <div class="block">Use the validation returned by <a
                                            href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.html#getValidationForCell-org.apache.poi.ss.util.CellReference-"><code>getValidationForCell(CellReference)</code></a>
                                        if you
                                        want the error display details.
                                    </div>
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait,
                                    wait, wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="DataValidationEvaluator-org.apache.poi.ss.usermodel.Workbook-org.apache.poi.ss.formula.WorkbookEvaluatorProvider-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>DataValidationEvaluator</h4>
                                <pre>public&nbsp;DataValidationEvaluator(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Workbook.html"
                                        title="interface in org.apache.poi.ss.usermodel">Workbook</a>&nbsp;wb,
                               <a href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluatorProvider.html"
                                  title="interface in org.apache.poi.ss.formula">WorkbookEvaluatorProvider</a>&nbsp;provider)</pre>
                                <div class="block">Use the same formula evaluation context used for other operations, so
                                    cell value
                                    changes are automatically noticed
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>wb</code> - the workbook this operates on</dd>
                                    <dd><code>provider</code> - provider for formula evaluation</dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="getWorkbookEvaluator--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getWorkbookEvaluator</h4>
                                <pre>protected&nbsp;<a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html"
                                        title="class in org.apache.poi.ss.formula">WorkbookEvaluator</a>&nbsp;getWorkbookEvaluator()</pre>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>evaluator</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="clearAllCachedValues--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>clearAllCachedValues</h4>
                                <pre>public&nbsp;void&nbsp;clearAllCachedValues()</pre>
                                <div class="block">Call this whenever validation structures change,
                                    so future results stay in sync with the Workbook state.
                                </div>
                            </li>
                        </ul>
                        <a name="getValidationForCell-org.apache.poi.ss.util.CellReference-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getValidationForCell</h4>
                                <pre>public&nbsp;<a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataValidation.html"
                                        title="interface in org.apache.poi.ss.usermodel">DataValidation</a>&nbsp;getValidationForCell(<a
                                        href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                        title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;cell)</pre>
                                <div class="block">Finds and returns the <a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataValidation.html"
                                        title="interface in org.apache.poi.ss.usermodel"><code>DataValidation</code></a>
                                    for the cell, if there is
                                    one. Lookup is based on the first match from
                                    <a href="../../../../../org/apache/poi/ss/usermodel/DataValidation.html#getRegions--"><code>DataValidation.getRegions()</code></a>
                                    for the cell's sheet. DataValidation
                                    regions must be in the same sheet as the DataValidation. Allowed values
                                    expressions may reference other sheets, however.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>cell</code> - reference to check - use this in case the cell does not
                                        actually exist yet
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the DataValidation applicable to the given cell, or null if no
                                        validation applies
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getValidationContextForCell-org.apache.poi.ss.util.CellReference-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getValidationContextForCell</h4>
                                <pre>public&nbsp;<a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.DataValidationContext.html"
                                        title="class in org.apache.poi.ss.formula">DataValidationEvaluator.DataValidationContext</a>&nbsp;getValidationContextForCell(<a
                                        href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                        title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;cell)</pre>
                                <div class="block">Finds and returns the <a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.DataValidationContext.html"
                                        title="class in org.apache.poi.ss.formula"><code>DataValidationEvaluator.DataValidationContext</code></a>
                                    for the cell, if there is
                                    one. Lookup is based on the first match from
                                    <a href="../../../../../org/apache/poi/ss/usermodel/DataValidation.html#getRegions--"><code>DataValidation.getRegions()</code></a>
                                    for the cell's sheet. DataValidation
                                    regions must be in the same sheet as the DataValidation. Allowed values
                                    expressions may reference other sheets, however.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>cell</code> - reference to check</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the DataValidationContext applicable to the given cell, or null if no
                                        validation applies
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getValidationValuesForCell-org.apache.poi.ss.util.CellReference-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getValidationValuesForCell</h4>
                                <pre>public&nbsp;java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&gt;&nbsp;getValidationValuesForCell(<a
                                        href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                        title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;cell)</pre>
                                <div class="block">If <a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.html#getValidationForCell-org.apache.poi.ss.util.CellReference-"><code>getValidationForCell(CellReference)</code></a>
                                    returns an instance, and the
                                    <a href="../../../../../org/apache/poi/ss/usermodel/DataValidationConstraint.ValidationType.html"
                                       title="class in org.apache.poi.ss.usermodel"><code>DataValidationConstraint.ValidationType</code></a>
                                    is
                                    <a href="../../../../../org/apache/poi/ss/usermodel/DataValidationConstraint.ValidationType.html#LIST"><code>DataValidationConstraint.ValidationType.LIST</code></a>,
                                    return the valid
                                    values, whether they are from a static list or cell range.
                                    <p>
                                        For all other validation types, or no validation at all, this method
                                        returns null.
                                    <p>
                                        This method could throw an exception if the validation type is not LIST,
                                        but since this method is mostly useful in UI contexts, null seems the
                                        easier path.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>cell</code> - reference to check - use this in case the cell does not
                                        actually exist yet
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>returns an unmodifiable <code>List</code> of <a
                                            href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                            title="interface in org.apache.poi.ss.formula.eval"><code>ValueEval</code></a>s
                                        if applicable, or
                                        null
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getValidationValuesForConstraint-org.apache.poi.ss.formula.DataValidationEvaluator.DataValidationContext-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getValidationValuesForConstraint</h4>
                                <pre>protected static&nbsp;java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&gt;&nbsp;getValidationValuesForConstraint(<a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.DataValidationContext.html"
                                        title="class in org.apache.poi.ss.formula">DataValidationEvaluator.DataValidationContext</a>&nbsp;context)</pre>
                                <div class="block">static so enums can reference it without creating a whole instance
                                </div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>returns an unmodifiable <code>List</code> of <a
                                            href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                            title="interface in org.apache.poi.ss.formula.eval"><code>ValueEval</code></a>s,
                                        which may be empty
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="isValidCell-org.apache.poi.ss.util.CellReference-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>isValidCell</h4>
                                <pre>public&nbsp;boolean&nbsp;isValidCell(<a
                                        href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                        title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;cellRef)</pre>
                                <div class="block">Use the validation returned by <a
                                        href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.html#getValidationForCell-org.apache.poi.ss.util.CellReference-"><code>getValidationForCell(CellReference)</code></a>
                                    if you
                                    want the error display details. This is the validation checked by this
                                    method, which attempts to replicate Excel's data validation rules.
                                    <p>
                                        Note that to properly apply some validations, care must be taken to
                                        offset the base validation formula by the relative position of the
                                        current cell, or the wrong value is checked.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>cellRef</code> - The reference of the cell to evaluate</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>true if the cell has no validation or the cell value passes the
                                        defined validation, false if it fails
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="isType-org.apache.poi.ss.usermodel.Cell-org.apache.poi.ss.usermodel.CellType-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>isType</h4>
                                <pre>public static&nbsp;boolean&nbsp;isType(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&nbsp;cell,
                             <a href="../../../../../org/apache/poi/ss/usermodel/CellType.html"
                                title="enum in org.apache.poi.ss.usermodel">CellType</a>&nbsp;type)</pre>
                                <div class="block">Note that this assumes the cell cached value is up to date and in
                                    sync with data edits
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>cell</code> - The <a
                                            href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                            title="interface in org.apache.poi.ss.usermodel"><code>Cell</code></a> to
                                        check.
                                    </dd>
                                    <dd><code>type</code> - The <a
                                            href="../../../../../org/apache/poi/ss/usermodel/CellType.html"
                                            title="enum in org.apache.poi.ss.usermodel"><code>CellType</code></a> to
                                        check for.
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>true if the cell or cached cell formula result type match the given type</dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/DataValidationEvaluator.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html"
               title="class in org.apache.poi.ss.formula"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/ss/formula/DataValidationEvaluator.DataValidationContext.html"
               title="class in org.apache.poi.ss.formula"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/ss/formula/DataValidationEvaluator.html" target="_top">Frames</a>
        </li>
        <li><a href="DataValidationEvaluator.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
